#pragma semicolon 1

#define DEBUG

#define PLUGIN_AUTHOR "jenz"
#define PLUGIN_VERSION "1.3"
#define generic_length 256

#include <sourcemod>
#include <sdktools>
#include <socket>

//#pragma newdecls required
int present = 0;
int targethuman = 0;
int stuck_counter[MAXPLAYERS + 1];

//admins & vips
int admins[MAXPLAYERS + 1];
int vips[MAXPLAYERS + 1];

//socket for bot input
Handle global_socket;

public Plugin myinfo = 
{
	name = "coordinates for the bot",
	author = PLUGIN_AUTHOR,
	description = "hello ",
	version = PLUGIN_VERSION,
	url = ""
};

public void OnPluginStart()
{
	//talking
	RegConsoleCmd("sm_autism", cmd_talk, "talking to the bot through java application");
	
	//hooks
	HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
	
	//socket otherwise declare in public OnConfigsExecuted(){}
	Handle socket = SocketCreate(SOCKET_UDP, OnSocketError);
	SocketSetOption(socket, SocketReuseAddr, 1);
	SocketBind(socket, "127.0.0.1", 48475);
	connect(socket);
	global_socket = socket;
}

public Action cmd_talk(int client, int args)
{	
	char msg[generic_length];
	char info[generic_length];
	GetCmdArgString(info, sizeof(info));
	if (strlen(info) == 0)
	{
		PrintToChat(client, "Add a message to the command if autism bot is ingame and running on discord");
		return Plugin_Handled;
	}
	Format(msg, sizeof(msg), "clientmessage: %s", info);
	send_socket_msg(msg, strlen(msg));
	return Plugin_Handled;
}

public void Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	targethuman = 0;
}

public void OnMapStart()
{
	CreateTimer(0.2, recursive_pressing, INVALID_HANDLE, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
	CreateTimer(10.0, bot_check_connect, INVALID_HANDLE, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

public bool TraceEntityFilterPlayer(int entity, int contentsMask)
{
	return (entity > GetMaxClients() || !entity);
}

public void send_socket_msg(char[] query_msg, int len)
{
	if (global_socket != INVALID_HANDLE && SocketIsConnected(global_socket))
		SocketSendTo(global_socket, query_msg, len, "127.0.0.1", 48477); //udp
}

public Action bot_check_connect(Handle timer, any data)
{
	if (!IsValidClient(present) && GetClientCount(false) < 63)
	{
		char msg[generic_length];
		//PrintToChatAll("sending UDP message...");
		Format(msg, sizeof(msg), "connect to ze");
		send_socket_msg(msg, strlen(msg));
	}
	return Plugin_Continue;
}

public Action recursive_pressing(Handle timer, any data)
{
	if (IsValidClient(present) && IsPlayerAlive(present))
	{
		char message[generic_length * 7];
		float present_bot_coords[3];
		GetClientAbsOrigin(present, present_bot_coords);
		int targeteam = 0;
		if (GetClientTeam(present) != 3)
		{
			//2 = autismo is zm and should follow closest moving zm
			targeteam = 2;
		}
		else
		{
			//3 = autismo is human and should follow closest moving ct
			targeteam = 3;
		}
		bool find_closest_match = true;
		if (IsValidClient(targethuman) && GetClientTeam(targethuman) == targeteam && IsPlayerAlive(targethuman))
		{
			float distance_limit = 10000.0;
			if (admins[targethuman])
				distance_limit = distance_limit * 5;
			else if (vips[targethuman])
				distance_limit = distance_limit * 2.5;
			find_closest_match = is_client_stuck_or_afk(targethuman);
			if (!find_closest_match)
			{	//float dist_target = get_square_distance(targethuman, present_bot_coords);
				//this is alternative approach to assume range
				
				float pos[3];
				GetEntPropVector(present, Prop_Send, "m_vecOrigin", pos);
				float dist_target = get_power_distance(targethuman, pos);
				find_closest_match = dist_target < distance_limit ? false : true;
			}
		}
		if (find_closest_match)
			targethuman = GetClosestClient_option1(present, targeteam);
		
		if (IsValidClient(targethuman))
		{	//float dist_target = get_square_distance(targethuman, present_bot_coords);
			
			float pos[3];
			GetEntPropVector(present, Prop_Send, "m_vecOrigin", pos);
			float dist_target = get_power_distance(targethuman, pos);
			int target_enemy = find_closest_enemy(present, targeteam);
			//dist_cap matching with distance_cap in python and enemy distance
			float dist_cap = 6000.0;
			if (IsValidClient(target_enemy))
			{
				float enemy_distance = get_power_distance(target_enemy, pos);
				if (enemy_distance < 2500)
					faceclient(target_enemy);
				else if (dist_target > dist_cap)
					faceclient(targethuman);
			}
			else if (dist_target > dist_cap)
				faceclient(targethuman);
			int keys = GetClientButtons(targethuman);
			char keyinput[generic_length * 2];
			int counter = 0;
			int countercap = 5;
			//check ladder = 0, water = 1, in air(surfing) = 2 TODO
			
			int bot_on_type = -1;
			if (GetEntityMoveType(present) == MOVETYPE_LADDER)
				bot_on_type = 0;
			int ilevel = GetEntProp(present, Prop_Data, "m_nWaterLevel");
			if (ilevel >= 2)
				bot_on_type = 1;
			while (!strlen(keyinput) && counter < countercap)
			{
				if (keys & IN_FORWARD)
					Format(keyinput, sizeof(keyinput), "-back; wait 5; +forward; wait 5; ");
				else if (keys & IN_BACK)
					Format(keyinput, sizeof(keyinput), "-forward; wait 5; +back; wait 5; ");
				if (keys & IN_MOVELEFT)
					Format(keyinput, sizeof(keyinput), "%s -moveright; wait 5; +moveleft; wait 5; ", keyinput);
				else if (keys & IN_MOVERIGHT)
					Format(keyinput, sizeof(keyinput), "%s -moveleft; wait 5; +moveright; wait 5; ", keyinput);
				if (keys & IN_JUMP)
					Format(keyinput, sizeof(keyinput), "%s +jump; wait 5; ", keyinput);
				if (keys & IN_DUCK)
					Format(keyinput, sizeof(keyinput), "%s +duck; wait 5; ", keyinput);
				counter++;
			}
			float clientangles[3];
			GetClientAbsAngles(targethuman, clientangles);
			Format(message, sizeof(message), "keyinput: %s clientangles: %f %f %f dist_target: %f targethuman: %N bot_on_type: %i", keyinput, clientangles[0], clientangles[1], clientangles[2], dist_target, targethuman, bot_on_type);
			send_socket_msg(message, strlen(message));
		}
	}
	return Plugin_Continue;
}

public void faceclient(int target_human)
{
	float TargetPos[3];
	float ClientPos[3];
	float Result[3];
	GetClientEyePosition(targethuman, TargetPos);
	GetClientEyePosition(present, ClientPos);
	MakeVectorFromPoints(ClientPos, TargetPos, Result);
	GetVectorAngles(Result, Result);
	TeleportEntity(present, NULL_VECTOR, Result, NULL_VECTOR);
}

stock bool IsValidClient(int client)
{
	if (client > 0 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client))
		return true;
	return false;
}

stock bool is_client_stuck_or_afk(int client)
{
	float flVel[3];
	GetEntPropVector(client, Prop_Data, "m_vecAbsVelocity", flVel);
	if (flVel[0] < 10.0 && flVel[1] < 10.0)
		stuck_counter[client]++;
	else
		stuck_counter[client] = 0;
	if (stuck_counter[client] > 10)
	{
		return true;
	}
	return false;
}

public float get_square_distance(int client, float []present_bot_coords)
{
	float pos[3];
	GetClientAbsOrigin(client, pos);
	float dx = present_bot_coords[0] - pos[0];
	float dy = present_bot_coords[1] - pos[1];
	float dz = FloatAbs(present_bot_coords[2] - pos[2]);
	return SquareRoot(dx*dx + dy*dy + dz*dz);
}

public int find_closest_enemy(int entity, int targeteam)
{
	float pos[3];
	float nearestdistance = -1.0;
	int nearest = -1;
	GetEntPropVector(entity, Prop_Send, "m_vecOrigin", pos);
	for (int i = 1; i <= MaxClients; i++)
	if (IsValidClient(i) && IsPlayerAlive(i) && GetClientTeam(i) != targeteam)
	{
		float dist_target = get_power_distance(i, pos);
		if (nearestdistance < 0 || dist_target < nearestdistance)
		{
			nearest = i;
			nearestdistance = dist_target;
		}
	}
	return nearest;
}

public int GetClosestClient_option1(int entity, int targeteam)
{
	bool adminpresent = false;
	bool vippresent = false;
	float distance_limit = 10000.0;
	float pos[3];
	float nearestdistance = -1.0;
	int nearest = -1;
	GetEntPropVector(entity, Prop_Send, "m_vecOrigin", pos);
	for (int i = 1; i <= MaxClients; i++)
	if (IsValidClient(i) && IsPlayerAlive(i) && GetClientTeam(i) == targeteam && i != present)
	{
		float dist_target = get_power_distance(i, pos);
		if (admins[i] == 1 && dist_target < distance_limit * 5)
		{
			adminpresent = true;
			vippresent = false;
		}
		else if (vips[i] == 1 && !adminpresent && dist_target < distance_limit * 2.5)
		{
			vippresent = true;
		}
		if (adminpresent)
		{
			if (admins[i] == 0)
				continue;
		}
		else if (vippresent)
		{
			if (vips[i] == 0)
				continue;
		}
		if (is_client_stuck_or_afk(i))
			continue;
		if (nearestdistance < 0 || dist_target < nearestdistance)
		{
			nearest = i;
			nearestdistance = dist_target;
		}
	}
	return nearest;
}

public float get_power_distance(int target_player, float [3]pos)
{
	float vec[3];
	GetClientAbsOrigin(target_player, vec);
	return Pow(vec[2]-pos[2], 2.0)+Pow(vec[1]-pos[1], 2.0)+Pow(vec[0]-pos[0], 2.0);
}

public bool FilterClient(int entity, int contentsMask, int client)
{
	if (entity == client)
		return false;
	return true;
}

public void OnClientPostAdminCheck(int client)
{
	//STEAM_0:1:34783317
	//STEAM_0:1:60189040
	//[U:1:120378081]
	//[U:1:69566635]
	char auth[50];
	GetClientAuthId(client, AuthId_Engine, auth, sizeof(auth)); 
	if (StrEqual("[U:1:120378081]", auth, false))
	{
		present = client;
		bot_send_connected_msg();
	}
	else if (StrEqual("STEAM_0:1:60189040", auth, false))
	{
		present = client;
		bot_send_connected_msg();
	}
	if (CheckCommandAccess(client, "sm_kick", ADMFLAG_KICK))
		admins[client] = 1;
	else if (CheckCommandAccess(client, "sm_reserved", ADMFLAG_RESERVATION))
		vips[client] = 1;
	stuck_counter[client] = 0;
}

public OnSocketError(Handle socket, const int errorType, const int errorNum, any args)
{
    LogError("[MR] Socket error: %d (errno %d)", errorType, errorNum);
    CreateTimer(120.0, TimerConnect, socket, TIMER_HNDL_CLOSE);
}

stock void connect(Handle socket)
{
    if (!SocketIsConnected(socket))
        SocketConnect(socket, OnSocketConnected, OnSocketReceive, OnSocketDisconnected, "127.0.0.1", 48475);
}

public void OnClientDisconnect(int client)
{
	if (present == client)
	{
		present = 0;
	}
	admins[client] = 0;
	vips[client] = 0;
	stuck_counter[client] = 0;
}

public void bot_send_connected_msg()
{
	char msg[generic_length];
	Format(msg, sizeof(msg), "autismo connected");
	send_socket_msg(msg, strlen(msg));
}

//Socket callback
public OnSocketConnected(Handle socket, any arg)
{
	
}

//manage message
public OnSocketReceive(Handle socket, char[] receiveData, const dataSize, any hFile)
{
    //PrintToChatAll("receiveData: %s", receiveData);
}

public OnSocketDisconnected(Handle socket, any arg)
{
    CreateTimer(120.0, TimerConnect, socket, TIMER_HNDL_CLOSE);
}

public Action TimerConnect(Handle timer, any arg)
{
    connect(arg);
    return Plugin_Handled;
}